## flatbuffers 1.11.0%2Bdfsg1

=== debian/changelog ===
flatbuffers (1.11.0+dfsg1-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fixup again symbol files

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 22 Mar 2020 17:17:26 +0100

flatbuffers (1.11.0+dfsg1-1.2) unstable; urgency=medium

  * Non-maintainer upload
  * Refresh symbols from unstable build logs.
    This fixes FTBFS on mips64el.

 -- Balint Reczey <rbalint@ubuntu.com>  Sat, 21 Mar 2020 17:35:47 +0100

flatbuffers (1.11.0+dfsg1-1.1) unstable; urgency=medium

  * Non-maintainer upload
  * Fix odd version number that I uploaded with accidentally (I'm sorry)

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 20 Jan 2020 12:14:42 +0100

flatbuffers (1.11.0+dfsg1-1.1~rbalint1) unstable; urgency=medium

  * Non-maintainer upload (Closes: #949329)
  * Update symbols from sid build logs and local build to fix FTBFS

 -- Balint Reczey <rbalint@ubuntu.com>  Sun, 19 Jan 2020 22:22:01 +0100

flatbuffers (1.11.0+dfsg1-1) unstable; urgency=medium

  [ Maximiliano Curia ]
  * Initial release. (Closes: #823037)
  * New upstream release (1.10.0).
  * Bump debhelper build-dep and compat to 12
  * Bump to Standards-Version 4.3.0
  * Use the hardening=+all deb build option
  * Add missing package sections
  * Add symbols to be managed with pkgkde symbolshelper
  * New upstream release (1.11.0).
  * Update symbols files
  * Release to unstable

  [ Balint Reczey ]
  * Add Salsa CI configuration
  * debian/control: Fix typo libsdevel -> libdevel
  * debian/control: Make unique short descriptions
  * Override false positive source-contains-prebuilt-doxygen-documentation
    Lintian warning
  * Add packaging TODO
  * Exclude prebuilt jars from original upstream tarball
  * debian/watch: Support repacked source
  * New import of upstream version 1.10.0 as 1.10.0+dfsg1 excluding the jars
  * debian/gitlab-ci.yml: Disable reprotest until cmake is fixed

 -- Maximiliano Curia <maxy@debian.org>  Tue, 30 Jul 2019 10:40:36 -0300

## flatbuffers 1.11.0+dfsg1

=== grpc/samples/greeter/Makefile ===
CXXFLAGS ?= -I../../../include
LDFLAGS ?=

.PHONY: all
all: server client

greeter_generated.h: greeter.fbs
	flatc --grpc --cpp $<

server: server.cpp greeter.grpc.fb.cc greeter_generated.h greeter.grpc.fb.h
	g++ -std=c++11 -O2 $(CXXFLAGS) $(LDFLAGS) -lgpr -lgrpc -lgrpc++ server.cpp greeter.grpc.fb.cc -o $@

client: client.cpp greeter.grpc.fb.cc greeter_generated.h greeter.grpc.fb.h
	g++ -std=c++11 -O2 $(CXXFLAGS) $(LDFLAGS) -lgpr -lgrpc -lgrpc++ client.cpp greeter.grpc.fb.cc -o $@

=== debian/changelog ===
flatbuffers (1.11.0+dfsg1-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 08 Dec 2019 13:08:08 -0800

=== debian/control ===
Source: flatbuffers
Section: devel
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Maximiliano Curia <maxy@debian.org>
Uploaders: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Build-Depends: cmake (>= 2.8), debhelper (>= 12), pkg-kde-tools (>= 0.6)
Standards-Version: 4.3.0
Homepage: http://google.github.io/flatbuffers/
Vcs-Browser: https://salsa.debian.org/debian/flatbuffers
Vcs-Git: https://salsa.debian.org/debian/flatbuffers.git

Package: flatbuffers-compiler
Architecture: any
Multi-Arch: foreign
Depends:
 libflatbuffers1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: efficient cross platform serialization library - compiler
 FlatBuffers is an efficient cross platform serialization library for C++, C#,
 C, Go, Java, JavaScript, TypeScript, PHP, and Python. It was originally
 created at Google for game development and other performance-critical
 applications.
 .
 This package contains the flat buffer compiler that is used for translating
 from .proto files (containing the definitions) to the language binding for the
 supported languages.

Package: flatbuffers-compiler-dev
Architecture: any
Multi-Arch: same
Depends:
 flatbuffers-compiler (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: efficient cross platform serialization library - cmake files
 FlatBuffers is an efficient cross platform serialization library for C++, C#,
 C, Go, Java, JavaScript, TypeScript, PHP, and Python. It was originally
 created at Google for game development and other performance-critical
 applications.
 .
 This package contains the development cmake files needed to use
 flatbuffer-compiler in a cross compiling environment.

Package: libflatbuffers-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 flatbuffers-compiler-dev (= ${binary:Version}),
 libflatbuffers1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: efficient cross platform serialization library - development files
 FlatBuffers is an efficient cross platform serialization library for C++, C#,
 C, Go, Java, JavaScript, TypeScript, PHP, and Python. It was originally
 created at Google for game development and other performance-critical
 applications.
 .
 This package contains the development headers and static libraries needed for
 writing C++ applications.

Package: libflatbuffers1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: efficient cross platform serialization library - shared library
 FlatBuffers is an efficient cross platform serialization library for C++, C#,
 C, Go, Java, JavaScript, TypeScript, PHP, and Python. It was originally
 created at Google for game development and other performance-critical
 applications.
 .
 This package contains the runtime library needed for C++ applications.

## flatbuffers 1.12.1~git20200711.33e2d80%2Bdfsg1

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: flatbuffers
+Priority: optional
 Section: devel
-Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Maximiliano Curia <maxy@debian.org>
-Uploaders: Nobuhiro Iwamatsu <iwamatsu@debian.org>
-Build-Depends: cmake (>= 2.8), debhelper (>= 12), pkg-kde-tools (>= 0.6)
-Standards-Version: 4.3.0
+Maintainer: Maximiliano Curia <maxy@debian.org>
+Uploaders: Nobuhiro Iwamatsu <iwamatsu@debian.org>,
+           Sascha Steinbiss <satta@debian.org>
+Build-Depends: cmake (>= 2.8), debhelper-compat (= 10), pkg-kde-tools (>= 0.6), dh-python, python3-all, python3-setuptools
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: http://google.github.io/flatbuffers/
 Vcs-Browser: https://salsa.debian.org/debian/flatbuffers
 Vcs-Git: https://salsa.debian.org/debian/flatbuffers.git
@@ -73,3 +74,16 @@
  applications.
  .
  This package contains the runtime library needed for C++ applications.
+
+Package: python3-flatbuffers
+Section: python
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}
+Description: efficient cross platform serialization library - Python bindings
+ FlatBuffers is an efficient cross platform serialization library for C++, C#,
+ C, Go, Java, JavaScript, TypeScript, PHP, and Python. It was originally
+ created at Google for game development and other performance-critical
+ applications.
+ .
+ This package contains python3 flatbuffers API.

## flatbuffers 1.12.1~git20200711.33e2d80+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
# generate compile_commands.json
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
include(CheckCXXSymbolExists)

project(FlatBuffers)

# NOTE: Code coverage only works on Linux & OSX.
option(FLATBUFFERS_CODE_COVERAGE "Enable the code coverage build option." OFF)
option(FLATBUFFERS_BUILD_TESTS "Enable the build of tests and samples." ON)
option(FLATBUFFERS_INSTALL "Enable the installation of targets." ON)
option(FLATBUFFERS_BUILD_FLATLIB "Enable the build of the flatbuffers library"
       ON)
option(FLATBUFFERS_BUILD_FLATC "Enable the build of the flatbuffers compiler"
       ON)
option(FLATBUFFERS_STATIC_FLATC "Build flatbuffers compiler with -static flag"
       OFF)
option(FLATBUFFERS_BUILD_FLATHASH "Enable the build of flathash" ON)
option(FLATBUFFERS_BUILD_GRPCTEST "Enable the build of grpctest" OFF)
option(FLATBUFFERS_BUILD_SHAREDLIB
       "Enable the build of the flatbuffers shared library"
       OFF)
option(FLATBUFFERS_LIBCXX_WITH_CLANG "Force libc++ when using Clang" ON)
# NOTE: Sanitizer check only works on Linux & OSX (gcc & llvm).
option(FLATBUFFERS_CODE_SANITIZE
      "Add '-fsanitize' flags to 'flattests' and 'flatc' targets."
      OFF)
option(FLATBUFFERS_PACKAGE_REDHAT
       "Build an rpm using the 'package' target."
       OFF)
option(FLATBUFFERS_PACKAGE_DEBIAN
       "Build an deb using the 'package' target."
       OFF)
option(FLATBUFFERS_BUILD_CPP17
       "Enable the build of c++17 test target. \"
       Requirements: Clang6, GCC7, MSVC2017 (_MSC_VER >= 1914)  or higher."
       OFF)
option(FLATBUFFERS_BUILD_LEGACY
       "Run C++ code generator with '--cpp-std c++0x' switch."
       OFF)
option(FLATBUFFERS_ENABLE_PCH
       "Enable precompile headers support for 'flatbuffers' and 'flatc'. \"
        Only work if CMake supports 'target_precompile_headers'. \"
        This can speed up compilation time."
       OFF)

if(NOT FLATBUFFERS_BUILD_FLATC AND FLATBUFFERS_BUILD_TESTS)
    message(WARNING
    "Cannot build tests without building the compiler. Tests will be disabled.")
    set(FLATBUFFERS_BUILD_TESTS OFF)
endif()

if(DEFINED FLATBUFFERS_MAX_PARSING_DEPTH)
  # Override the default recursion depth limit.
  add_definitions(-DFLATBUFFERS_MAX_PARSING_DEPTH=${FLATBUFFERS_MAX_PARSING_DEPTH})
  message(STATUS "FLATBUFFERS_MAX_PARSING_DEPTH: ${FLATBUFFERS_MAX_PARSING_DEPTH}")
endif()

# Auto-detect locale-narrow 'strtod_l' and  'strtoull_l' functions.
if(NOT DEFINED FLATBUFFERS_LOCALE_INDEPENDENT)
  set(FLATBUFFERS_LOCALE_INDEPENDENT 0)
  if(MSVC)
    check_cxx_symbol_exists(_strtof_l stdlib.h FLATBUFFERS_HAS_STRTOF_L)
    check_cxx_symbol_exists(_strtoui64_l stdlib.h FLATBUFFERS_HAS_STRTOULL_L)
  else()
    check_cxx_symbol_exists(strtof_l stdlib.h FLATBUFFERS_HAS_STRTOF_L)
    check_cxx_symbol_exists(strtoull_l stdlib.h FLATBUFFERS_HAS_STRTOULL_L)
  endif()
  if(FLATBUFFERS_HAS_STRTOF_L AND FLATBUFFERS_HAS_STRTOULL_L)
    set(FLATBUFFERS_LOCALE_INDEPENDENT 1)
  endif()
endif()
add_definitions(-DFLATBUFFERS_LOCALE_INDEPENDENT=$<BOOL:${FLATBUFFERS_LOCALE_INDEPENDENT}>)

set(FlatBuffers_Library_SRCS
  include/flatbuffers/base.h
  include/flatbuffers/flatbuffers.h
  include/flatbuffers/hash.h
  include/flatbuffers/idl.h
  include/flatbuffers/util.h
  include/flatbuffers/reflection.h
  include/flatbuffers/reflection_generated.h
  include/flatbuffers/stl_emulation.h
  include/flatbuffers/flexbuffers.h
  include/flatbuffers/registry.h
  include/flatbuffers/minireflect.h
  src/idl_parser.cpp
  src/idl_gen_text.cpp
  src/reflection.cpp
  src/util.cpp
)

set(FlatBuffers_Compiler_SRCS
  ${FlatBuffers_Library_SRCS}
  src/idl_gen_cpp.cpp
  src/idl_gen_csharp.cpp
  src/idl_gen_dart.cpp
  src/idl_gen_kotlin.cpp
  src/idl_gen_go.cpp
  src/idl_gen_java.cpp
  src/idl_gen_js_ts.cpp
  src/idl_gen_php.cpp
  src/idl_gen_python.cpp
  src/idl_gen_lobster.cpp
  src/idl_gen_lua.cpp
  src/idl_gen_rust.cpp
  src/idl_gen_fbs.cpp
  src/idl_gen_grpc.cpp
  src/idl_gen_json_schema.cpp
  src/idl_gen_swift.cpp
  src/flatc.cpp
  src/flatc_main.cpp
  include/flatbuffers/code_generators.h
  src/code_generators.cpp
  grpc/src/compiler/schema_interface.h
  grpc/src/compiler/cpp_generator.h
  grpc/src/compiler/cpp_generator.cc
  grpc/src/compiler/go_generator.h
  grpc/src/compiler/go_generator.cc
  grpc/src/compiler/java_generator.h
  grpc/src/compiler/java_generator.cc
  grpc/src/compiler/python_generator.h
  grpc/src/compiler/python_private_generator.h
  grpc/src/compiler/python_generator.cc
  grpc/src/compiler/swift_generator.h
  grpc/src/compiler/swift_generator.cc
)

set(FlatHash_SRCS
  include/flatbuffers/hash.h
  src/flathash.cpp
)

set(FlatBuffers_Tests_SRCS
  ${FlatBuffers_Library_SRCS}
  src/idl_gen_fbs.cpp
  tests/test.cpp
  tests/test_assert.h
  tests/test_assert.cpp
  tests/test_builder.h
  tests/test_builder.cpp
  tests/native_type_test_impl.h
  tests/native_type_test_impl.cpp
  include/flatbuffers/code_generators.h
  src/code_generators.cpp
  # file generate by running compiler on tests/monster_test.fbs
  ${CMAKE_CURRENT_BINARY_DIR}/tests/monster_test_generated.h
  # file generate by running compiler on namespace_test/namespace_test1.fbs
  ${CMAKE_CURRENT_BINARY_DIR}/tests/namespace_test/namespace_test1_generated.h
  ${CMAKE_CURRENT_BINARY_DIR}/tests/namespace_test/namespace_test2_generated.h
  # file generate by running compiler on union_vector/union_vector.fbs
  ${CMAKE_CURRENT_BINARY_DIR}/tests/union_vector/union_vector_generated.h
  # file generate by running compiler on tests/arrays_test.fbs
  ${CMAKE_CURRENT_BINARY_DIR}/tests/arrays_test_generated.h
  # file generate by running compiler on tests/native_type_test.fbs
  ${CMAKE_CURRENT_BINARY_DIR}/tests/native_type_test_generated.h
  # file generate by running compiler on tests/monster_extra.fbs
  ${CMAKE_CURRENT_BINARY_DIR}/tests/monster_extra_generated.h
  # file generate by running compiler on tests/monster_test.fbs
  ${CMAKE_CURRENT_BINARY_DIR}/tests/monster_test_bfbs_generated.h
)

set(FlatBuffers_Tests_CPP17_SRCS
  ${FlatBuffers_Library_SRCS}
  tests/test_assert.h
  tests/test_assert.cpp
  tests/cpp17/test_cpp17.cpp
  # file generate by running compiler on tests/monster_test.fbs
  ${CMAKE_CURRENT_BINARY_DIR}/tests/cpp17/generated_cpp17/monster_test_generated.h
  ${CMAKE_CURRENT_BINARY_DIR}/tests/monster_test_generated.h
)

set(FlatBuffers_Sample_Binary_SRCS
  include/flatbuffers/flatbuffers.h
  samples/sample_binary.cpp
  # file generated by running compiler on samples/monster.fbs
  ${CMAKE_CURRENT_BINARY_DIR}/samples/monster_generated.h
)

set(FlatBuffers_Sample_Text_SRCS
  ${FlatBuffers_Library_SRCS}
  samples/sample_text.cpp
  # file generated by running compiler on samples/monster.fbs
  ${CMAKE_CURRENT_BINARY_DIR}/samples/monster_generated.h
)

set(FlatBuffers_Sample_BFBS_SRCS
  ${FlatBuffers_Library_SRCS}
  samples/sample_bfbs.cpp
  # file generated by running compiler on samples/monster.fbs
  ${CMAKE_CURRENT_BINARY_DIR}/samples/monster_generated.h
)

set(FlatBuffers_GRPCTest_SRCS
  include/flatbuffers/flatbuffers.h
  include/flatbuffers/grpc.h
  include/flatbuffers/util.h
  src/util.cpp
  tests/monster_test.grpc.fb.h
  tests/test_assert.h
  tests/test_builder.h
  tests/monster_test.grpc.fb.cc
  tests/test_assert.cpp
  tests/test_builder.cpp
  grpc/tests/grpctest.cpp
  grpc/tests/message_builder_test.cpp
  # file generate by running compiler on tests/monster_test.fbs
  ${CMAKE_CURRENT_BINARY_DIR}/tests/monster_test_generated.h
)

# source_group(Compiler FILES ${FlatBuffers_Compiler_SRCS})
# source_group(Tests FILES ${FlatBuffers_Tests_SRCS})

if(EXISTS "${CMAKE_TOOLCHAIN_FILE}")
  # do not apply any global settings if the toolchain
  # is being configured externally
  message(STATUS "Using toolchain file: ${CMAKE_TOOLCHAIN_FILE}.")
elseif(APPLE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -stdlib=libc++")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic -Werror -Wextra -Wno-unused-parameter")
  set(FLATBUFFERS_PRIVATE_CXX_FLAGS "-Wold-style-cast")
elseif(CMAKE_COMPILER_IS_GNUCXX)
  if(CYGWIN)
    set(CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -std=gnu++11")
  else(CYGWIN)
    set(CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -std=c++0x")
  endif(CYGWIN)
  set(CMAKE_CXX_FLAGS
    "${CMAKE_CXX_FLAGS} -Wall -pedantic -Werror -Wextra -Werror=shadow")
  set(FLATBUFFERS_PRIVATE_CXX_FLAGS "-Wold-style-cast")
  if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.4)
    if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 7.0)
      set(CMAKE_CXX_FLAGS
        "${CMAKE_CXX_FLAGS} -faligned-new -Werror=implicit-fallthrough=2")
    endif()
    set(CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -Wunused-result -Werror=unused-result -Wunused-parameter -Werror=unused-parameter")
  endif()

  # Certain platforms such as ARM do not use signed chars by default
  # which causes issues with certain bounds checks.
  set(CMAKE_CXX_FLAGS
    "${CMAKE_CXX_FLAGS} -fsigned-char")

elseif(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
  set(CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -std=c++0x -Wall -pedantic -Werror -Wextra -Wno-unused-parameter")
  set(FLATBUFFERS_PRIVATE_CXX_FLAGS "-Wold-style-cast")
  if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.8)
    list(APPEND FLATBUFFERS_PRIVATE_CXX_FLAGS "-Wimplicit-fallthrough" "-Wextra-semi" "-Werror=unused-private-field") # enable warning
  endif()
  if(FLATBUFFERS_LIBCXX_WITH_CLANG)
    if(NOT "${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
      set(CMAKE_CXX_FLAGS
          "${CMAKE_CXX_FLAGS} -stdlib=libc++")
    endif()
    if(NOT ("${CMAKE_SYSTEM_NAME}" MATCHES "FreeBSD" OR
            "${CMAKE_SYSTEM_NAME}" MATCHES "Linux"))
      set(CMAKE_EXE_LINKER_FLAGS
          "${CMAKE_EXE_LINKER_FLAGS} -lc++abi")
    endif()
  endif()

  # Certain platforms such as ARM do not use signed chars by default
  # which causes issues with certain bounds checks.
  set(CMAKE_CXX_FLAGS
    "${CMAKE_CXX_FLAGS} -fsigned-char")

elseif(MSVC)
  # Visual Studio pedantic build settings
  # warning C4512: assignment operator could not be generated
  # warning C4316: object allocated on the heap may not be aligned
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4 /WX /wd4512 /wd4316")
endif()

if(FLATBUFFERS_CODE_COVERAGE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage")
  set(CMAKE_EXE_LINKER_FLAGS
      "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
endif()

function(add_fsanitize_to_target _target _sanitizer)
  if(WIN32)
    target_compile_definitions(${_target} PRIVATE FLATBUFFERS_MEMORY_LEAK_TRACKING)
    message(STATUS "Sanitizer MSVC::_CrtDumpMemoryLeaks added to ${_target}")
  else()
    # FLATBUFFERS_CODE_SANITIZE: boolean {ON,OFF,YES,NO} or string with list of sanitizer.
    # List of sanitizer is string starts with '=': "=address,undefined,thread,memory".
    if((${CMAKE_CXX_COMPILER_ID} MATCHES "Clang") OR
      ((${CMAKE_CXX_COMPILER_ID} MATCHES "GNU") AND NOT (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.9"))
    )
      set(_sanitizer_flags "=address,undefined")
      if(_sanitizer MATCHES "=.*")
        # override default by user-defined sanitizer list
        set(_sanitizer_flags ${_sanitizer})
      endif()
      target_compile_options(${_target} PRIVATE
        -g -fsigned-char -fno-omit-frame-pointer
        "-fsanitize${_sanitizer_flags}")
      target_link_libraries(${_target} PRIVATE
        "-fsanitize${_sanitizer_flags}")
      set_property(TARGET ${_target} PROPERTY POSITION_INDEPENDENT_CODE ON)
      message(STATUS "Sanitizer ${_sanitizer_flags} added to ${_target}")
    endif()
  endif()
endfunction()

function(add_pch_to_target _target _pch_header)
  if(COMMAND target_precompile_headers)
    target_precompile_headers(${_target} PRIVATE ${_pch_header})
    if(NOT MSVC)
      set_source_files_properties(src/util.cpp PROPERTIES SKIP_PRECOMPILE_HEADERS ON)
    endif()
  endif()
endfunction()

if(BIICODE)
  include(biicode/cmake/biicode.cmake)
  return()
endif()

include_directories(include)
include_directories(grpc)

=== tests/fuzzer/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

project(FlatBuffersFuzzerTests)

option(BUILD_DEBUGGER "Compile a debugger with main() and without libFuzzer" OFF)

if(NOT DEFINED FLATBUFFERS_MAX_PARSING_DEPTH)
  # Force checking of RecursionError in the test
  set(FLATBUFFERS_MAX_PARSING_DEPTH 8)
endif()
message(STATUS "FLATBUFFERS_MAX_PARSING_DEPTH: ${FLATBUFFERS_MAX_PARSING_DEPTH}")

# Usage '-fsanitize=address' doesn't allowed with '-fsanitize=memory'.
# MemorySanitizer will not work out-of-the-box, and will instead report false
# positives coming from uninstrumented code. Need to re-build both C++ standard
# library: https://github.com/google/sanitizers/wiki/MemorySanitizerLibcxxHowTo
option(USE_MSAN "Use MSAN instead of ASASN" OFF)

# Use Clang linker.
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fuse-ld=lld")

# add_link_options(-stdlib=libc++)

add_compile_options(
  # -stdlib=libc++ # Use Clang libc++ instead of GNU.
  -std=c++14
  -Wall
  -pedantic
  -Werror
  -Wextra
  -Wno-unused-parameter
  -fsigned-char
  -fno-omit-frame-pointer
  -g # Generate source-level debug information
  # -flto # enable link-time optimisation
)

# https://llvm.org/docs/Passes.html save IR to see call graph make one bitcode
# file:> llvm-link *.bc -o out.bc print call-graph:> opt out.bc -analyze -print-
# callgraph &> callgraph.txt set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -save-temps
# -flto")

# A special target with fuzzer+sanitizer flags.
add_library(fuzzer_config INTERFACE)

target_compile_options(
  fuzzer_config
  INTERFACE
    -fsanitize-coverage=edge,trace-cmp
    $<$<BOOL:NOT ${USE_MSAN}>:
      -fsanitize=fuzzer,undefined,address
    >
    $<$<BOOL:${USE_MSAN}>:
      -fsanitize=fuzzer,undefined,memory
      -fsanitize-memory-track-origins=2
    >
)

target_link_libraries(
  fuzzer_config
  INTERFACE
    $<$<BOOL:NOT ${USE_MSAN}>:
      -fsanitize=fuzzer,undefined,address
    >
    $<$<BOOL:${USE_MSAN}>:
      -fsanitize=fuzzer,undefined,memory
    >
)

set(FLATBUFFERS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../")

set(FlatBuffers_Library_SRCS
    ${FLATBUFFERS_DIR}/include/flatbuffers/base.h
    ${FLATBUFFERS_DIR}/include/flatbuffers/flatbuffers.h
    ${FLATBUFFERS_DIR}/include/flatbuffers/hash.h
    ${FLATBUFFERS_DIR}/include/flatbuffers/idl.h
    ${FLATBUFFERS_DIR}/include/flatbuffers/util.h
    ${FLATBUFFERS_DIR}/include/flatbuffers/reflection.h
    ${FLATBUFFERS_DIR}/include/flatbuffers/reflection_generated.h
    ${FLATBUFFERS_DIR}/include/flatbuffers/stl_emulation.h
    ${FLATBUFFERS_DIR}/include/flatbuffers/flexbuffers.h
    ${FLATBUFFERS_DIR}/include/flatbuffers/registry.h
    ${FLATBUFFERS_DIR}/include/flatbuffers/minireflect.h
    ${FLATBUFFERS_DIR}/src/idl_parser.cpp
    ${FLATBUFFERS_DIR}/src/idl_gen_text.cpp
    ${FLATBUFFERS_DIR}/src/reflection.cpp
    ${FLATBUFFERS_DIR}/src/util.cpp
    ${FLATBUFFERS_DIR}/tests/test_assert.cpp
)

include_directories(${FLATBUFFERS_DIR}/include)
include_directories(${FLATBUFFERS_DIR}/tests)

add_library(flatbuffers_fuzzed STATIC ${FlatBuffers_Library_SRCS})
# Use PUBLIC to force 'fuzzer_config' for all dependent targets
target_link_libraries(flatbuffers_fuzzed PUBLIC fuzzer_config)

# FLATBUFFERS_ASSERT should assert in Release as well. Redefine
# FLATBUFFERS_ASSERT macro definition. Declare as PUBLIC to cover asserts in all
# included header files.
target_compile_definitions(
  flatbuffers_fuzzed
  PUBLIC
    FLATBUFFERS_ASSERT=fuzzer_assert_impl
    FLATBUFFERS_ASSERT_INCLUDE="${CMAKE_CURRENT_SOURCE_DIR}/fuzzer_assert.h"
  PRIVATE
    FLATBUFFERS_MAX_PARSING_DEPTH=${FLATBUFFERS_MAX_PARSING_DEPTH}
)

# Setup fuzzer tests.

add_executable(scalar_fuzzer flatbuffers_scalar_fuzzer.cc)
target_link_libraries(scalar_fuzzer PRIVATE flatbuffers_fuzzed)

add_executable(parser_fuzzer flatbuffers_parser_fuzzer.cc)
target_link_libraries(parser_fuzzer PRIVATE flatbuffers_fuzzed)

add_executable(verifier_fuzzer flatbuffers_verifier_fuzzer.cc)
target_link_libraries(verifier_fuzzer PRIVATE flatbuffers_fuzzed)

# Build debugger for weird cases found with fuzzer.
if(BUILD_DEBUGGER)
  add_library(flatbuffers_nonfuzz STATIC ${FlatBuffers_Library_SRCS})
  target_compile_definitions(
    flatbuffers_nonfuzz
    PUBLIC
      FLATBUFFERS_ASSERT=fuzzer_assert_impl
      FLATBUFFERS_ASSERT_INCLUDE="${CMAKE_CURRENT_SOURCE_DIR}/fuzzer_assert.h"
    PRIVATE
      FLATBUFFERS_MAX_PARSING_DEPTH=${FLATBUFFERS_MAX_PARSING_DEPTH}
  )
  add_executable(scalar_debug flatbuffers_scalar_fuzzer.cc scalar_debug.cpp)
  target_link_libraries(scalar_debug PRIVATE flatbuffers_nonfuzz)
endif(BUILD_DEBUGGER)

=== debian/changelog ===
flatbuffers (1.12.1~git20200711.33e2d80+dfsg1-0.6) unstable; urgency=medium

  * Non-maintainer upload.
  * Mark three more symbols as optional, to fix s390x and ppc64el in Ubuntu.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 08 Jan 2021 16:29:01 +0100

flatbuffers (1.12.1~git20200711.33e2d80+dfsg1-0.5) unstable; urgency=medium

  * Non-maintainer upload.

  [ Vasyl Gello ]
  * Mark a few other symbols as optional to fix FTBFS on sid/s390x.

  [ Mattia Rizzolo ]
  * Match all the Std:: symbols out there.
  * Manually handle symbols arch subst without pkgkde-tools.

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 02 Jan 2021 14:45:07 +0100

flatbuffers (1.12.1~git20200711.33e2d80+dfsg1-0.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Make C++ template symbols optional and refresh them (Closes: #976921)
  * Bump standards version to 4.5.1 (no changes required)
  * Install python3-flatbuffers as indep (Closes: #976069)

 -- Vasyl Gello <vasek.gello@gmail.com>  Thu, 24 Dec 2020 13:19:42 +0000

flatbuffers (1.12.1~git20200711.33e2d80+dfsg1-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop useless symbols disappearing with -O3 optimization level

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 Jul 2020 13:15:52 +0200

flatbuffers (1.12.1~git20200711.33e2d80+dfsg1-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian: Adjust symbols from buildlogs.
  * debian: Fix failing tests on hppa/mipsel/mips64el.

 -- Vasyl Gello <vasek.gello@gmail.com>  Fri, 17 Jul 2020 18:15:18 +0200

flatbuffers (1.12.1~git20200711.33e2d80+dfsg1-0.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Vasyl Gello ]
  * New upstream version 1.12.1~git20200711.33e2d80+dfsg1.
    + Fixed build with GCC-10.  Closes: #957212
  * debian: Remove obsoleted patch
  * debian: Update symbols file.

  [ Mattia Rizzolo ]
  * Mark python3-flatbuffers as M-A:foreign, from the M-A hinter.

 -- Vasyl Gello <vasek.gello@gmail.com>  Wed, 15 Jul 2020 16:30:01 +0200

flatbuffers (1.11.0+dfsg1-3) unstable; urgency=medium

  * Team upload
  * Refresh symbols for non-amd64 archs

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 04 Jul 2020 23:41:07 +0200

flatbuffers (1.11.0+dfsg1-2) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Team upload

  [ Vasyl Gello ]
  * debian: Adjust symbols for libflatbuffers1/alpha
  * debian: Add gbp.conf
  * debian: fix Lintian warnings
  * debian: fix FTBFS on hurd/i386

  [ Alexander Gerasiov ]
  * d/control, d/rules: Add python3-flatbuffers.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 01 Jul 2020 18:04:01 +0200

flatbuffers (1.11.0+dfsg1-1.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix symbol files on {stable,unstable}/amd64

 -- Vasyl Gello <vasek.gello@gmail.com>  Mon, 25 May 2020 17:13:26 +0300

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,9 @@
 Priority: optional
 Section: devel
 Maintainer: Maximiliano Curia <maxy@debian.org>
-Uploaders: Nobuhiro Iwamatsu <iwamatsu@debian.org>,
-           Sascha Steinbiss <satta@debian.org>
-Build-Depends: cmake (>= 2.8), debhelper-compat (= 10), pkg-kde-tools (>= 0.6), dh-python, python3-all, python3-setuptools
-Standards-Version: 4.5.0
+Uploaders: Nobuhiro Iwamatsu <iwamatsu@debian.org>
+Build-Depends: cmake (>= 2.8), debhelper-compat (= 13), dh-python, python3-all, python3-setuptools
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: http://google.github.io/flatbuffers/
 Vcs-Browser: https://salsa.debian.org/debian/flatbuffers

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

# SOURCE_DATE_EPOCH set by dh
export DEB_CPPFLAGS_MAINT_APPEND = -Wno-error=date-time

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DFLATBUFFERS_BUILD_SHAREDLIB=ON

override_dh_auto_build-arch:
	dh_auto_build --arch

# Python3 build
override_dh_auto_build-indep:
	dh_auto_build --indep
	set -e; cd python && for pv in $(shell py3versions -vr); do \
		VERSION=$(DEB_VERSION) python$$pv setup.py build; \
	done

override_dh_auto_install-arch:
	dh_auto_install --arch

# Python3 install.
override_dh_auto_install-indep:
	dh_auto_install --indep
	set -e; \
	cd python && for pv in $(shell py3versions -vr); do \
		VERSION=$(DEB_VERSION) python$$pv setup.py install \
			--install-layout=deb --no-compile \
			--root=$(CURDIR)/debian/python3-flatbuffers; \
	done
	find $(CURDIR)/debian/python3-flatbuffers -name 'flatbuffers-*-nspkg.pth' -delete

=== debian/watch ===
version=4
opts="dversionmangle=s/.dfsg[0-9]*//,repacksuffix=+dfsg1,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%flatbuffers-$1.tar.gz%" \
      https://github.com/google/flatbuffers/tags \
      (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## flatbuffers 2.0.6+dfsg1

=== debian/changelog ===
flatbuffers (2.0.6+dfsg1-3) unstable; urgency=medium

  * Add -Wno-error=stringop-overflow to fix s390x FTBFS.

 -- Mo Zhou <lumin@debian.org>  Fri, 30 Sep 2022 19:32:34 -0400

flatbuffers (2.0.6+dfsg1-2) unstable; urgency=medium

  * Specify -Wno-error=maybe-uninitialized for GCC-12 (Closes: #1012928)
  * Refresh symbols control file.

 -- Mo Zhou <lumin@debian.org>  Sat, 03 Sep 2022 14:23:09 -0400

flatbuffers (2.0.6+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Fri, 08 Jul 2022 08:03:50 -0700

flatbuffers (2.0.6+dfsg1-1~exp3) experimental; urgency=medium

  * Patch to fix s390x FTBFS.

 -- Mo Zhou <lumin@debian.org>  Sun, 19 Jun 2022 21:15:24 -0700

flatbuffers (2.0.6+dfsg1-1~exp2) experimental; urgency=medium

  * Only track symbols for amd64 architecture. Manually crafting C++ symbol
    file for a hundred architectures sounds like nothing but a burden to me.

 -- Mo Zhou <lumin@debian.org>  Sat, 18 Jun 2022 13:40:39 -0700

flatbuffers (2.0.6+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream version 2.0.6+dfsg1
  * Append myself to Uploaders.
  * Update Files-Excluded list.
  * Change build directory to $(CURDIR) to prevent test failure.
  * Bump SOVERSION from 1 to 2; rename packages.
  * Remove upstream-merged patches.
  * Install the generated pkgconfig file.
  * Refresh symbols control file.
  * Overhaul d/copyright due to massive codebase change.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Mon, 30 May 2022 17:07:31 -0700

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Priority: optional
 Section: devel
 Maintainer: Maximiliano Curia <maxy@debian.org>
-Uploaders: Nobuhiro Iwamatsu <iwamatsu@debian.org>
+Uploaders: Nobuhiro Iwamatsu <iwamatsu@debian.org>,
+           Mo Zhou <lumin@debian.org>
 Build-Depends: cmake (>= 2.8), debhelper-compat (= 13), dh-python, python3-all, python3-setuptools
 Standards-Version: 4.5.1
 Rules-Requires-Root: no
@@ -14,7 +15,7 @@
 Architecture: any
 Multi-Arch: foreign
 Depends:
- libflatbuffers1 (= ${binary:Version}),
+ libflatbuffers2 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Description: efficient cross platform serialization library - compiler
@@ -49,7 +50,7 @@
 Multi-Arch: same
 Depends:
  flatbuffers-compiler-dev (= ${binary:Version}),
- libflatbuffers1 (= ${binary:Version}),
+ libflatbuffers2 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Description: efficient cross platform serialization library - development files
@@ -61,7 +62,7 @@
  This package contains the development headers and static libraries needed for
  writing C++ applications.
 
-Package: libflatbuffers1
+Package: libflatbuffers2
 Section: libs
 Architecture: any
 Multi-Arch: same
